=== debian/changelog ===
libdeflate (1.2-1) unstable; urgency=medium

  * New upstream version
  * Compile using profile guided optimization

 -- Michael R. Crusoe <michael.crusoe@gmail.com>  Tue, 15 Jan 2019 06:05:37 -0800

libdeflate (1.1-1) unstable; urgency=medium

  * New upstream version
  * Remove all patches, they were applied upstream.

 -- Michael R. Crusoe <michael.crusoe@gmail.com>  Sun, 23 Dec 2018 15:02:48 -0800

libdeflate (1.0-5) unstable; urgency=medium

  * debian/patches/add_cppflags: Add CPPFLAGS to implicit rule overrides
  * debian/watch: skip pre-releases
  * debian/tests, debian/control: add basic autopkgtest

 -- Michael R. Crusoe <michael.crusoe@gmail.com>  Wed, 19 Dec 2018 02:55:01 -0800

libdeflate (1.0-4) unstable; urgency=medium

  [ Andreas Tille ]
  * ARM: NEON is not available with the FPU emulation (Thanks to Adrian Bunk
    for the patch)
    Closes: #916700

 -- Michael R. Crusoe <michael.crusoe@gmail.com>  Tue, 18 Dec 2018 01:11:20 -0800

libdeflate (1.0-3) unstable; urgency=medium

  * debian/patches/armel_no_neon: use a more direct method of disabling
    NEON on the armel architecture.

 -- Michael R. Crusoe <michael.crusoe@gmail.com>  Fri, 07 Dec 2018 02:37:13 -0800

libdeflate (1.0-2) unstable; urgency=medium

  * debian/rules: Try turning off NEON on armel to fix the build; ask
    upstream's build to be more verbose
  * debian/control: Add "Multi-Arch: same" hints
  * debian/libdeflate0.symbols: add Build-Depends-Package

 -- Michael R. Crusoe <michael.crusoe@gmail.com>  Thu, 06 Dec 2018 19:52:52 -0800

libdeflate (1.0-1) unstable; urgency=medium

  * Initial release (Closes: #911076)

 -- Michael R. Crusoe <michael.crusoe@gmail.com>  Mon, 15 Oct 2018 01:59:04 -0700
