=== debian/rules ===
#!/usr/bin/make -f

# for hardening you might like to uncomment this:
export DEB_BUILD_MAINT_OPTIONS=hardening=+all

%:
	dh $@


override_dh_auto_build:
	make CFLAGS="$(shell dpkg-buildflags --get CFLAGS) -fprofile-generate" \
		LDFLAGS="$(shell dpkg-buildflags --get LDFLAGS) -fprofile-generate"\
		V=1 all test_programs -j$(shell nproc) \
		"INSTALL=install --strip-program=true"
	for level in $(shell seq 1 12); do \
		./benchmark -$${level} ./lib/deflate_compress.c > /dev/null; \
	done
	make CFLAGS="$(shell dpkg-buildflags --get CFLAGS) -fprofile-use" \
		V=1 all test_programs -j$(shell nproc) \
		"INSTALL=install --strip-program=true"

override_dh_auto_install:
	make CFLAGS="$(shell dpkg-buildflags --get CFLAGS) -fprofile-use" \
		-j$(shell nproc) install DESTDIR=$(CURDIR)/debian/tmp \
		AM_UPDATE_INFO_DIR=no "INSTALL=install --strip-program=true"	

override_dh_auto_test:
ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
	cp -a README.md README.md.save
	./gzip README.md
	./gunzip README.md.gz
	diff -u README.md.save README.md && rm README.md.save
	./test_checksums 
	./checksum -A -t README.md
	./checksum -t README.md
endif

override_dh_install:
	dh_install
	d-shlibmove --commit \
		    --multiarch \
		    --devunversioned \
		    --exclude-la \
		    --movedev libdeflate.h usr/include \
		    *.so
