=== debian/tests/control ===
Tests: compile-sample-programs
Depends: @, gcc, bash, libc6-dev
