## libdeflate 1.5

=== Makefile ===
--- 
+++ 
@@ -11,46 +11,70 @@
 #
 # Define DISABLE_ZLIB to disable support for the zlib wrapper format.
 #
-##############################################################################
-
-#### Common compiler flags.
-#### Flags given here are not intended to be overridden, but you can add more
-#### by defining CFLAGS in the environment or on the 'make' command line.
+# Define PREFIX to override the installation prefix, like './configure --prefix'
+# in autotools-based projects (default: /usr/local)
+#
+# Define BINDIR to override where to install binaries, like './configure
+# --bindir' in autotools-based projects (default: PREFIX/bin)
+#
+# Define INCDIR to override where to install headers, like './configure
+# --includedir' in autotools-based projects (default: PREFIX/include)
+#
+# Define LIBDIR to override where to install libraries, like './configure
+# --libdir' in autotools-based projects (default: PREFIX/lib)
+#
+# Define DESTDIR to override the installation destination directory
+# (default: empty string)
+#
+# You can also specify custom CFLAGS, CPPFLAGS, and/or LDFLAGS.
+#
+##############################################################################
+
+#### Common compiler flags.  You can add additional flags by defining CFLAGS
+#### in the environment or on the 'make' command line.
+####
+#### The default optimization flags can be overridden, e.g. via CFLAGS="-O3" or
+#### CFLAGS="-O0 -fno-omit-frame-pointer".  But this usually isn't recommended;
+#### you're unlikely to get significantly better performance even with -O3.
 
 cc-option = $(shell if $(CC) $(1) -c -x c /dev/null -o /dev/null \
 	      1>&2 2>/dev/null; then echo $(1); fi)
 
 override CFLAGS :=							\
-	$(CFLAGS) -O2 -fomit-frame-pointer -std=c99 -I. -Icommon	\
+	-O2 -fomit-frame-pointer $(CFLAGS) -std=c99 -I. -Icommon	\
 	-Wall -Wundef							\
 	$(call cc-option,-Wpedantic)					\
 	$(call cc-option,-Wdeclaration-after-statement)			\
 	$(call cc-option,-Wmissing-prototypes)				\
 	$(call cc-option,-Wstrict-prototypes)				\
-	$(call cc-option,-Wvla)
+	$(call cc-option,-Wvla)						\
+	$(call cc-option,-Wimplicit-fallthrough)
 
 # We don't define any CPPFLAGS, but support the user specifying it.
 
 ##############################################################################
 
-PREFIX ?= /usr
+PREFIX ?= /usr/local
+BINDIR ?= $(PREFIX)/bin
+INCDIR ?= $(PREFIX)/include
+LIBDIR ?= $(PREFIX)/lib
 
 SOVERSION          := 0
+
 STATIC_LIB_SUFFIX  := .a
-SHARED_LIB_SUFFIX  := .so.$(SOVERSION)
-SHARED_LIB_CFLAGS  := -fPIC
-SHARED_LIB_LDFLAGS := -Wl,-soname=libdeflate$(SHARED_LIB_SUFFIX)
 PROG_SUFFIX        :=
 PROG_CFLAGS        :=
 HARD_LINKS         := 1
 
 # Compiling for Windows with MinGW?
 ifneq ($(findstring -mingw,$(shell $(CC) -dumpmachine 2>/dev/null)),)
-    SOVERSION          :=
     STATIC_LIB_SUFFIX  := static.lib
-    SHARED_LIB_SUFFIX  := .dll
+    SHARED_LIB         := libdeflate.dll
+    SHARED_LIB_SYMLINK :=
     SHARED_LIB_CFLAGS  :=
-    SHARED_LIB_LDFLAGS := -Wl,--out-implib,libdeflate.lib
+    SHARED_LIB_LDFLAGS := -Wl,--out-implib,libdeflate.lib \
+                          -Wl,--output-def,libdeflate.def \
+                          -Wl,--add-stdcall-alias
     PROG_SUFFIX        := .exe
     PROG_CFLAGS        := -static -municode
     HARD_LINKS         :=
@@ -64,6 +88,20 @@
         AR := $(shell echo $(CC) | \
                 sed -E 's/g?cc(-?[0-9]+(\.[0-9]+)*)?(\.exe)?$$/ar\3/')
     endif
+
+# macOS?
+else ifeq ($(shell uname),Darwin)
+   SHARED_LIB         := libdeflate.$(SOVERSION).dylib
+   SHARED_LIB_SYMLINK := libdeflate.dylib
+   SHARED_LIB_CFLAGS  := -fPIC
+   SHARED_LIB_LDFLAGS := -install_name $(SHARED_LIB)
+
+# Linux, FreeBSD, etc.
+else
+   SHARED_LIB         := libdeflate.so.$(SOVERSION)
+   SHARED_LIB_SYMLINK := libdeflate.so
+   SHARED_LIB_CFLAGS  := -fPIC
+   SHARED_LIB_LDFLAGS := -Wl,-soname=$(SHARED_LIB)
 endif
 
 ##############################################################################
@@ -89,7 +127,6 @@
 #### Library
 
 STATIC_LIB := libdeflate$(STATIC_LIB_SUFFIX)
-SHARED_LIB := libdeflate$(SHARED_LIB_SUFFIX)
 
 LIB_CFLAGS += $(CFLAGS) -fvisibility=hidden -D_ANSI_SOURCE
 
@@ -144,11 +181,11 @@
 
 DEFAULT_TARGETS += $(SHARED_LIB)
 
-ifdef SOVERSION
+ifdef SHARED_LIB_SYMLINK
 # Create the symlink libdeflate.so => libdeflate.so.$SOVERSION
-libdeflate.so:$(SHARED_LIB)
+$(SHARED_LIB_SYMLINK):$(SHARED_LIB)
 	$(QUIET_LN) ln -sf $+ $@
-DEFAULT_TARGETS += libdeflate.so
+DEFAULT_TARGETS += $(SHARED_LIB_SYMLINK)
 endif
 
 # Rebuild if CC, LIB_CFLAGS, or CPPFLAGS changed
@@ -239,23 +276,34 @@
 
 all:$(DEFAULT_TARGETS)
 
+# Install the files.  Note: not all versions of the 'install' program have the
+# '-D' and '-t' options, so don't use them; use portable commands only.
 install:all
-	install -Dm644 -t $(DESTDIR)$(PREFIX)/lib $(STATIC_LIB)
-	install -Dm755 -t $(DESTDIR)$(PREFIX)/lib $(SHARED_LIB)
-	ln -sf $(SHARED_LIB) $(DESTDIR)$(PREFIX)/lib/libdeflate.so
-	install -Dm644 -t $(DESTDIR)$(PREFIX)/include libdeflate.h
-	install -Dm755 gzip $(DESTDIR)$(PREFIX)/bin/libdeflate-gzip
-	ln -f $(DESTDIR)$(PREFIX)/bin/libdeflate-gzip $(DESTDIR)$(PREFIX)/bin/libdeflate-gunzip
+	install -d $(DESTDIR)$(LIBDIR) $(DESTDIR)$(INCDIR) $(DESTDIR)$(BINDIR)
+	install -m644 $(STATIC_LIB) $(DESTDIR)$(LIBDIR)
+	install -m755 $(SHARED_LIB) $(DESTDIR)$(LIBDIR)
+	ln -sf $(SHARED_LIB) $(DESTDIR)$(LIBDIR)/libdeflate.so
+	install -m644 libdeflate.h $(DESTDIR)$(INCDIR)
+	install -m755 gzip $(DESTDIR)$(BINDIR)/libdeflate-gzip
+	ln -f $(DESTDIR)$(BINDIR)/libdeflate-gzip $(DESTDIR)$(BINDIR)/libdeflate-gunzip
 
 uninstall:
-	rm -f $(DESTDIR)$(PREFIX)/lib/$(STATIC_LIB) \
-		$(DESTDIR)$(PREFIX)/lib/$(SHARED_LIB) \
-		$(DESTDIR)$(PREFIX)/lib/libdeflate.so \
-		$(DESTDIR)$(PREFIX)/include/libdeflate.h \
-		$(DESTDIR)$(PREFIX)/bin/libdeflate-gzip \
-		$(DESTDIR)$(PREFIX)/bin/libdeflate-gunzip
+	rm -f $(DESTDIR)$(LIBDIR)/$(STATIC_LIB) \
+		$(DESTDIR)$(LIBDIR)/$(SHARED_LIB) \
+		$(DESTDIR)$(LIBDIR)/libdeflate.so \
+		$(DESTDIR)$(INCDIR)/libdeflate.h \
+		$(DESTDIR)$(BINDIR)/libdeflate-gzip \
+		$(DESTDIR)$(BINDIR)/libdeflate-gunzip
 
 test_programs:$(TEST_PROGRAMS)
+
+# A minimal 'make check' target.  This only runs some quick tests;
+# use tools/run_tests.sh if you want to run the full tests.
+check:test_programs
+	./benchmark$(PROG_SUFFIX) < ./benchmark$(PROG_SUFFIX)
+	for prog in test_*; do		\
+		./$$prog || exit 1;	\
+	done
 
 help:
 	@echo "Available targets:"
@@ -271,7 +319,7 @@
 		lib/*.dllobj lib/*/*.dllobj \
 		programs/*.o programs/*.obj \
 		$(DEFAULT_TARGETS) $(TEST_PROGRAMS) programs/config.h \
-		libdeflate.lib libdeflatestatic.lib \
+		libdeflate.lib libdeflate.def libdeflatestatic.lib \
 		.lib-cflags .prog-cflags
 
 realclean: clean
