=== debian/changelog ===
libdeflate (1.5-3) unstable; urgency=medium

  * Source only upload

 -- Michael R. Crusoe <michael.crusoe@gmail.com>  Wed, 12 Feb 2020 18:04:25 +0100

libdeflate (1.5-2) unstable; urgency=medium

  * Standards-Version: 4.5.0 (routine-update)
  * Remove obsolete fields Name from debian/upstream/metadata.
  * New binary package libdeflate-tools

 -- Michael R. Crusoe <michael.crusoe@gmail.com>  Mon, 10 Feb 2020 12:57:43 +0100

libdeflate (1.5-1) unstable; urgency=medium

  * New upstream version

 -- Michael R. Crusoe <michael.crusoe@gmail.com>  Wed, 01 Jan 2020 11:45:12 +0100

libdeflate (1.4-1) unstable; urgency=medium

  * New upstream version

 -- Michael R. Crusoe <michael.crusoe@gmail.com>  Sat, 28 Dec 2019 12:00:11 +0100

libdeflate (1.3-3) unstable; urgency=medium

  * Drop valgrind build-dep

 -- Michael R. Crusoe <michael.crusoe@gmail.com>  Fri, 13 Sep 2019 15:28:11 +0200

libdeflate (1.3-2) unstable; urgency=medium

  * add patch from upstream: test_slow_decompression: skip by default since it's flaky
    Should fix build on ppc64el

 -- Michael R. Crusoe <michael.crusoe@gmail.com>  Fri, 13 Sep 2019 13:24:25 +0200

libdeflate (1.3-1) unstable; urgency=medium

  * New upstream version, now provides libdeflate-g{un,}zip in /usr/bin
  * debhelper-compat 12
  * Standards-Version: 4.4.0
  * Remove trailing whitespace in debian/rules
  * Set upstream metadata fields: Name.

 -- Michael R. Crusoe <michael.crusoe@gmail.com>  Fri, 23 Aug 2019 12:28:07 +0200
