## libdeflate 1.6

=== Makefile ===
--- 
+++ 
@@ -25,6 +25,10 @@
 #
 # Define DESTDIR to override the installation destination directory
 # (default: empty string)
+#
+# Define FREESTANDING to build a freestanding library, i.e. a library that
+# doesn't link to any libc functions like malloc(), free(), and memcpy().
+# All users will need to call libdeflate_set_memory_allocator().
 #
 # You can also specify custom CFLAGS, CPPFLAGS, and/or LDFLAGS.
 #
@@ -41,7 +45,7 @@
 	      1>&2 2>/dev/null; then echo $(1); fi)
 
 override CFLAGS :=							\
-	-O2 -fomit-frame-pointer $(CFLAGS) -std=c99 -I. -Icommon	\
+	-O2 -fomit-frame-pointer $(CFLAGS) -std=c99 -I.			\
 	-Wall -Wundef							\
 	$(call cc-option,-Wpedantic)					\
 	$(call cc-option,-Wdeclaration-after-statement)			\
@@ -50,7 +54,11 @@
 	$(call cc-option,-Wvla)						\
 	$(call cc-option,-Wimplicit-fallthrough)
 
-# We don't define any CPPFLAGS, but support the user specifying it.
+FREESTANDING :=
+ifdef FREESTANDING
+override CPPFLAGS += -DFREESTANDING
+LIB_CFLAGS += -ffreestanding -nostdlib
+endif
 
 ##############################################################################
 
@@ -132,7 +140,7 @@
 
 LIB_HEADERS := $(wildcard lib/*.h) $(wildcard lib/*/*.h)
 
-LIB_SRC := lib/aligned_malloc.c lib/deflate_decompress.c \
+LIB_SRC := lib/deflate_decompress.c lib/utils.c \
 	   $(wildcard lib/*/cpu_features.c)
 
 DECOMPRESSION_ONLY :=
@@ -214,9 +222,7 @@
 TEST_PROG_COMMON_SRC := programs/test_util.c
 TEST_PROG_SRC        := programs/benchmark.c \
 			programs/checksum.c \
-			programs/test_checksums.c \
-			programs/test_incomplete_codes.c \
-			programs/test_slow_decompression.c
+			$(filter-out $(TEST_PROG_COMMON_SRC),$(wildcard programs/test_*.c))
 
 NONTEST_PROGRAMS := $(NONTEST_PROG_SRC:programs/%.c=%$(PROG_SUFFIX))
 DEFAULT_TARGETS  += $(NONTEST_PROGRAMS)
