=== debian/changelog ===
libdeflate (1.6-1) unstable; urgency=medium

  * New upstream version
  * Add salsa-ci file (routine-update)
  * Rules-Requires-Root: no (routine-update)
  * Wrap long lines in changelog entries: 1.3-2.
  * Set upstream metadata fields: Bug-Database, Bug-Submit, Repository,
    Repository-Browse.
  * Add new symbols
  * Mark libdeflate0 at Multi-Arch: same

 -- Michael R. Crusoe <michael.crusoe@gmail.com>  Wed, 13 May 2020 12:04:06 +0200
