=== debian/control ===
--- 
+++ 
@@ -12,8 +12,10 @@
 Vcs-Browser: https://salsa.debian.org/med-team/libdeflate
 Vcs-Git: https://salsa.debian.org/med-team/libdeflate.git
 Homepage: https://github.com/ebiggers/libdeflate
+Rules-Requires-Root: no
 
 Package: libdeflate0
+Multi-Arch: same
 Architecture: any
 Section: libs
 Depends: ${shlibs:Depends},
