=== debian/changelog ===
libdeflate (1.7-2ubuntu2) impish; urgency=medium

  * Merge with Debian; remaining changes:
    - remove an old patch that disables a test, it doesn't seem needed
      and the description is wrong, pointed out in the MIR review #1908502
  * Revert: debian/rules: Specify minimum FPU (-mfpu=vfpv3-d16) on armhf.
  * lib/arm/crc32_impl.h: Use "arch=armv8-a+simd+crc" as the target arch.

 -- Matthias Klose <doko@ubuntu.com>  Thu, 26 Aug 2021 11:50:07 +0200

libdeflate (1.7-2) unstable; urgency=medium

  * Team Upload
  * Fix FTCBFS: (Closes: #989942)
    + Let dh_auto_build pass cross tools to make.
    + Automatically skip pgo when DEB_BUILD_PROFILES contains cross.
    Thanks to Helmut Grohne!

 -- Nilesh Patra <nilesh@debian.org>  Sun, 22 Aug 2021 01:14:54 +0530

libdeflate (1.7-1ubuntu2) impish; urgency=medium

  * debian/rules: Specify minimum FPU (-mfpu=vfpv3-d16) on armhf

 -- Lukas Märdian <slyon@ubuntu.com>  Mon, 09 Aug 2021 17:25:50 +0200

libdeflate (1.7-1ubuntu1) hirsute; urgency=medium

  * debian/patches/simplify-tests:
    - remove an old patch that disables a test, it doesn't seem needed
      and the description is wrong, pointed out in the MIR review #1908502

 -- Sebastien Bacher <seb128@debian.org>  Tue, 09 Mar 2021 17:16:23 +0100

libdeflate (1.7-1) unstable; urgency=medium

  * New upstream version
  * Standards-Version: 4.5.1 (routine-update)
  * debhelper-compat 13 (routine-update)
  * Refresh patch

 -- Michael R. Crusoe <crusoe@debian.org>  Sun, 03 Jan 2021 14:36:39 +0100
