## libdeflate 1.10

=== Makefile ===
--- 
+++ 
@@ -5,6 +5,9 @@
 #
 # Define USE_SHARED_LIB to link the binaries to the shared library version of
 # libdeflate rather than to the static library version.
+#
+# Define DISABLE_SHARED to disable building and installing of shared library.
+# Defining this variable undefines USE_SHARED_LIB.
 #
 # Define DECOMPRESSION_ONLY to omit all compression code, building a
 # decompression-only library.  If doing this, you must also build a specific
@@ -36,6 +39,9 @@
 # You can also specify a custom CC, CFLAGS, CPPFLAGS, and/or LDFLAGS.
 #
 ##############################################################################
+
+VERSION = $(shell sed -n 's/\#define LIBDEFLATE_VERSION_STRING.*"\(.*\)"/\1/p' \
+	    libdeflate.h)
 
 #### Common compiler flags.  You can add additional flags by defining CFLAGS
 #### in the environment or on the 'make' command line.
@@ -83,8 +89,10 @@
 PROG_CFLAGS        :=
 HARD_LINKS         := 1
 
+TARGET_MACHINE     := $(shell $(CC) -dumpmachine 2>/dev/null)
+
 # Compiling for Windows with MinGW?
-ifneq ($(findstring -mingw,$(shell $(CC) -dumpmachine 2>/dev/null)),)
+ifneq ($(findstring -mingw,$(TARGET_MACHINE)),)
     STATIC_LIB_SUFFIX  := static.lib
     SHARED_LIB         := libdeflate.dll
     SHARED_LIB_SYMLINK :=
@@ -106,14 +114,21 @@
                 sed -E 's/g?cc(-?[0-9]+(\.[0-9]+)*)?(\.exe)?$$/ar\3/')
     endif
 
-# macOS?
-else ifeq ($(shell uname),Darwin)
+# Compiling for macOS?
+else ifneq ($(findstring -darwin,$(TARGET_MACHINE)),)
    SHARED_LIB         := libdeflate.$(SOVERSION).dylib
    SHARED_LIB_SYMLINK := libdeflate.dylib
    SHARED_LIB_CFLAGS  := -fPIC
    SHARED_LIB_LDFLAGS := -install_name $(SHARED_LIB)
 
-# Linux, FreeBSD, etc.
+# Compiling for Android?
+else ifneq ($(findstring -android,$(TARGET_MACHINE)),)
+   SHARED_LIB         := libdeflate.so
+   SHARED_LIB_SYMLINK :=
+   SHARED_LIB_CFLAGS  := -fPIC
+   SHARED_LIB_LDFLAGS := -Wl,-soname=$(SHARED_LIB)
+
+# Compiling for Linux, FreeBSD, etc.
 else
    SHARED_LIB         := libdeflate.so.$(SOVERSION)
    SHARED_LIB_SYMLINK := libdeflate.so
@@ -142,6 +157,7 @@
 .build-config: FORCE
 	@flags=$$(							\
 		echo 'USE_SHARED_LIB=$(USE_SHARED_LIB)';		\
+		echo 'DISABLE_SHARED=$(DISABLE_SHARED)';		\
 		echo 'DECOMPRESSION_ONLY=$(DECOMPRESSION_ONLY)';	\
 		echo 'DISABLE_GZIP=$(DISABLE_GZIP)';			\
 		echo 'DISABLE_ZLIB=$(DISABLE_ZLIB)';			\
@@ -216,7 +232,11 @@
 	$(QUIET_CCLD) $(CC) -o $@ $(LDFLAGS) $(LIB_CFLAGS) \
 		$(SHARED_LIB_LDFLAGS) -shared $+
 
+ifdef DISABLE_SHARED
+undefine SHARED_LIB_SYMLINK
+else
 DEFAULT_TARGETS += $(SHARED_LIB)
+endif
 
 ifdef SHARED_LIB_SYMLINK
 # Create the symlink libdeflate.so => libdeflate.so.$SOVERSION
@@ -300,12 +320,25 @@
 
 all:$(DEFAULT_TARGETS)
 
+# We don't generate the pkg-config file until install time, as needed
+# definitions might not exist until then.
+PKGCONFBASE := libdeflate.pc.in
+
 # Install the files.  Note: not all versions of the 'install' program have the
 # '-D' and '-t' options, so don't use them; use portable commands only.
-install:all
-	install -d $(DESTDIR)$(LIBDIR) $(DESTDIR)$(INCDIR) $(DESTDIR)$(BINDIR)
+install:all $(PKGCONFBASE)
+	install -d $(DESTDIR)$(LIBDIR)/pkgconfig $(DESTDIR)$(INCDIR)	\
+		$(DESTDIR)$(BINDIR)
 	install -m644 $(STATIC_LIB) $(DESTDIR)$(LIBDIR)
-	install -m755 $(SHARED_LIB) $(DESTDIR)$(LIBDIR)
+	if [ -z "$(DISABLE_SHARED)" ]; then				\
+		install -m755 $(SHARED_LIB) $(DESTDIR)$(LIBDIR);	\
+	fi
+	sed -e "s|@PREFIX@|$(PREFIX)|"					\
+	    -e "s|@LIBDIR@|$(LIBDIR)|"					\
+	    -e "s|@INCDIR@|$(INCDIR)|"					\
+	    -e "s|@VERSION@|$(VERSION)|"				\
+	    $(PKGCONFBASE) > $(DESTDIR)$(LIBDIR)/pkgconfig/libdeflate.pc
+	chmod 644 $(DESTDIR)$(LIBDIR)/pkgconfig/libdeflate.pc
 	install -m644 libdeflate.h $(DESTDIR)$(INCDIR)
 	install -m755 gzip$(PROG_SUFFIX) \
 		$(DESTDIR)$(BINDIR)/libdeflate-gzip$(PROG_SUFFIX)
@@ -319,50 +352,5 @@
 uninstall:
 	rm -f $(DESTDIR)$(LIBDIR)/$(STATIC_LIB)				\
 	      $(DESTDIR)$(LIBDIR)/$(SHARED_LIB)				\
+	      $(DESTDIR)$(LIBDIR)/pkgconfig/libdeflate.pc		\
 	      $(DESTDIR)$(INCDIR)/libdeflate.h				\
-	      $(DESTDIR)$(BINDIR)/libdeflate-gzip$(PROG_SUFFIX)		\
-	      $(DESTDIR)$(BINDIR)/libdeflate-gunzip$(PROG_SUFFIX)
-	if [ -n "$(SHARED_LIB_SYMLINK)" ]; then				\
-		rm -f $(DESTDIR)$(LIBDIR)/$(SHARED_LIB_SYMLINK);	\
-	fi
-
-test_programs:$(TEST_PROGRAMS)
-
-# A minimal 'make check' target.  This only runs some quick tests;
-# use scripts/run_tests.sh if you want to run the full tests.
-check:test_programs
-	LD_LIBRARY_PATH=. ./benchmark$(PROG_SUFFIX) < ./benchmark$(PROG_SUFFIX)
-	for prog in test_*; do		\
-		LD_LIBRARY_PATH=. ./$$prog || exit 1;	\
-	done
-
-# Run the clang static analyzer.
-scan-build:
-	scan-build --status-bugs make all test_programs
-
-# Run shellcheck on all shell scripts.
-shellcheck:
-	shellcheck scripts/*.sh
-
-help:
-	@echo "Available targets:"
-	@echo "------------------"
-	@for target in $(DEFAULT_TARGETS) $(TEST_PROGRAMS); do \
-		echo -e "$$target";		\
-	done
-
-clean:
-	rm -f *.a *.dll *.exe *.exp *.dylib *.so \
-		lib/*.o lib/*/*.o \
-		lib/*.obj lib/*/*.obj \
-		lib/*.dllobj lib/*/*.dllobj \
-		programs/*.o programs/*.obj \
-		$(DEFAULT_TARGETS) $(TEST_PROGRAMS) programs/config.h \
-		libdeflate.lib libdeflate.def libdeflatestatic.lib \
-		.build-config
-
-realclean: clean
-	rm -f tags cscope*
-
-FORCE:
-
