=== debian/changelog ===
libdeflate (1.10-2) unstable; urgency=medium

  * Team Upload.
  * Add patch to fix FTBFS on armhf (Closes: #1006139)
    + Thanks to Graham Inggs for pointing towards Ubuntu patch

 -- Nilesh Patra <nilesh@debian.org>  Thu, 10 Mar 2022 23:35:02 +0530

libdeflate (1.10-1) unstable; urgency=medium

  * Team upload.
  * New upstream version

 -- Andreas Tille <tille@debian.org>  Sun, 20 Feb 2022 08:30:56 +0100

libdeflate (1.9-1) unstable; urgency=medium

  * Team upload.
  * New upstream version
  * Add missing build dependency on dh addon.
  * Install pkgconfig file

 -- Andreas Tille <tille@debian.org>  Wed, 19 Jan 2022 17:10:52 +0100

libdeflate (1.8-1) unstable; urgency=medium

  * Team upload.
  * Fix watchfile to detect new versions on github
  * New upstream version
  * Standards-Version: 4.6.0 (routine-update)

 -- Andreas Tille <tille@debian.org>  Sun, 10 Oct 2021 10:20:38 +0200
