=== debian/control ===
--- 
+++ 
@@ -1,6 +1,5 @@
 Source: libdeflate
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
+Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
 Uploaders: Michael R. Crusoe <crusoe@debian.org>
 Section: science
 Priority: optional
@@ -8,8 +7,9 @@
                d-shlibs,
                zlib1g-dev,
                python3 <!nocheck>,
-               xxd <!nocheck>
-Standards-Version: 4.5.1
+               xxd <!nocheck>,
+               debhelper
+Standards-Version: 4.6.0
 Vcs-Browser: https://salsa.debian.org/med-team/libdeflate
 Vcs-Git: https://salsa.debian.org/med-team/libdeflate.git
 Homepage: https://github.com/ebiggers/libdeflate
