=== debian/watch ===
version=4

https://github.com/ebiggers/libdeflate/releases/latest .*/v?@ANY_VERSION@@ARCHIVE_EXT@
# skips pre-releases
