## libdeflate 1.12

=== debian/changelog ===
libdeflate (1.12-1) unstable; urgency=medium

  * Team upload.

  [ Andreas Tille ]
  * d/watch: Use proper filename for download

  [ Lance Lin ]
  * Updated to new version (1.12)

  [ Andreas Tille ]
  * Standards-Version: 4.6.1 (routine-update)
  * Remove trailing whitespace in debian/changelog (routine-update)

 -- Andreas Tille <tille@debian.org>  Thu, 23 Jun 2022 15:30:05 +0200
